Bug 802182 - Review Request: ironjacamar - Java Connector Architecture 1.6 implementation
Review Request: ironjacamar - Java Connector Architecture 1.6 implementation
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Juan Hernández
Fedora Extras Quality Assurance
:
Depends On: 730227 801614 801680 801865
Blocks:
  Show dependency treegraph
 
Reported: 2012-03-11 18:40 EDT by Ricardo Arguello
Modified: 2012-04-11 23:33 EDT (History)
3 users (show)

See Also:
Fixed In Version: ironjacamar-1.0.9-3.fc17
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-04-11 23:33:16 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
juan.hernandez: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Ricardo Arguello 2012-03-11 18:40:17 EDT
Spec URL:
http://ricardo.fedorapeople.org/package_review/ironjacamar/1/ironjacamar.spec

SRPM URL:
http://ricardo.fedorapeople.org/package_review/ironjacamar/1/ironjacamar-1.0.7-3.fc17.src.rpm

Description: The IronJacamar project implements the Java Connector Architecture 1.6 specification.
Comment 1 Juan Hernández 2012-03-23 05:50:36 EDT
I take this for review.
Comment 2 Juan Hernández 2012-03-23 07:18:16 EDT
Ricardo, can you please update to upstream 1.0.9 (was released on Mar 8 2012), then I will complete the review.
Comment 4 Juan Hernández 2012-03-26 04:50:58 EDT
The package doesn't build in Koji. I think that it is using ivy and trying to download artifacts from the web, which will never work in Koji. The failed Koji build is here:

http://koji.fedoraproject.org/koji/taskinfo?taskID=3932036

And the relevant error message in build.log is the following:

+ ant -Dbrew nexus clean docs
Buildfile: /builddir/build/BUILD/ironjacamar-1.0.9.Final/build.xml
    [mkdir] Created dir: /builddir/.ivy2/cache/org.apache.ivy/jars
      [get] Getting: https://repository.apache.org/content/repositories/releases/org/apache/ivy/ivy/2.2.0/ivy-2.2.0.jar
      [get] To: /builddir/.ivy2/cache/org.apache.ivy/jars/ivy-2.2.0.jar
      [get] Error getting https://repository.apache.org/content/repositories/releases/org/apache/ivy/ivy/2.2.0/ivy-2.2.0.jar to /builddir/.ivy2/cache/org.apache.ivy/jars/ivy-2.2.0.jar
BUILD FAILED
/builddir/build/BUILD/ironjacamar-1.0.9.Final/build.xml:292: java.net.UnknownHostException: repository.apache.org
	at java.net.AbstractPlainSocketImpl.connect(AbstractPlainSocketImpl.java:178)
	at java.net.SocksSocketImpl.connect(SocksSocketImpl.java:391)
	at java.net.Socket.connect(Socket.java:579)
	at sun.security.ssl.SSLSocketImpl.connect(SSLSocketImpl.java:612)
	at sun.security.ssl.BaseSSLSocketImpl.connect(BaseSSLSocketImpl.java:160)
	at sun.net.NetworkClient.doConnect(NetworkClient.java:180)
	at sun.net.www.http.HttpClient.openServer(HttpClient.java:388)
	at sun.net.www.http.HttpClient.openServer(HttpClient.java:483)
	at sun.net.www.protocol.https.HttpsClient.<init>(HttpsClient.java:278)
	at sun.net.www.protocol.https.HttpsClient.New(HttpsClient.java:335)
	at sun.net.www.protocol.https.AbstractDelegateHttpsURLConnection.getNewHttpClient(AbstractDelegateHttpsURLConnection.java:191)
	at sun.net.www.protocol.http.HttpURLConnection.plainConnect(HttpURLConnection.java:928)
	at sun.net.www.protocol.https.AbstractDelegateHttpsURLConnection.connect(AbstractDelegateHttpsURLConnection.java:177)
	at sun.net.www.protocol.https.HttpsURLConnectionImpl.connect(HttpsURLConnectionImpl.java:153)
	at org.apache.tools.ant.taskdefs.Get$GetThread.openConnection(Get.java:660)
	at org.apache.tools.ant.taskdefs.Get$GetThread.get(Get.java:579)
	at org.apache.tools.ant.taskdefs.Get$GetThread.run(Get.java:569)
Comment 6 Juan Hernández 2012-03-27 08:42:31 EDT
Package Review
==============

Key:
- = N/A
x = Check
! = Problem
? = Not evaluated

=== REQUIRED ITEMS ===
[!]  Rpmlint output:

Output of rpmlint of the source package:

$ rpmlint ironjacamar-1.0.9-2.fc17.src.rpm 
ironjacamar.src: W: invalid-url URL: http://www.jboss.org/ironjacamar HTTP Error 403: Forbidden
ironjacamar.src: W: invalid-url Source13: https://repository.jboss.org/nexus/service/local/repositories/releases/content/org/jboss/ironjacamar/ironjacamar-deployers-common/1.0.9.Final/ironjacamar-spec-api-1.0.9.Final.pom HTTP Error 404: The server has not found anything matching the request URI
ironjacamar.src: W: invalid-url Source12: https://repository.jboss.org/nexus/service/local/repositories/releases/content/org/jboss/ironjacamar/ironjacamar-deployers-common/1.0.9.Final/ironjacamar-common-api-1.0.9.Final.pom HTTP Error 404: The server has not found anything matching the request URI
ironjacamar.src: W: invalid-url Source11: https://repository.jboss.org/nexus/service/local/repositories/releases/content/org/jboss/ironjacamar/ironjacamar-deployers-common/1.0.9.Final/ironjacamar-validator-ant-1.0.9.Final.pom HTTP Error 404: The server has not found anything matching the request URI
ironjacamar.src: W: invalid-url Source10: https://repository.jboss.org/nexus/service/local/repositories/releases/content/org/jboss/ironjacamar/ironjacamar-deployers-common/1.0.9.Final/ironjacamar-core-api-1.0.9.Final.pom HTTP Error 404: The server has not found anything matching the request URI
ironjacamar.src: W: invalid-url Source9: https://repository.jboss.org/nexus/service/local/repositories/releases/content/org/jboss/ironjacamar/ironjacamar-deployers-common/1.0.9.Final/ironjacamar-validator-maven-1.0.9.Final.pom HTTP Error 404: The server has not found anything matching the request URI
ironjacamar.src: W: invalid-url Source8: https://repository.jboss.org/nexus/service/local/repositories/releases/content/org/jboss/ironjacamar/ironjacamar-deployers-common/1.0.9.Final/ironjacamar-common-spi-1.0.9.Final.pom HTTP Error 404: The server has not found anything matching the request URI
ironjacamar.src: W: invalid-url Source7: https://repository.jboss.org/nexus/service/local/repositories/releases/content/org/jboss/ironjacamar/ironjacamar-deployers-common/1.0.9.Final/ironjacamar-jdbc-1.0.9.Final.pom HTTP Error 404: The server has not found anything matching the request URI
ironjacamar.src: W: invalid-url Source6: https://repository.jboss.org/nexus/service/local/repositories/releases/content/org/jboss/ironjacamar/ironjacamar-deployers-common/1.0.9.Final/ironjacamar-core-impl-1.0.9.Final.pom HTTP Error 404: The server has not found anything matching the request URI
ironjacamar.src: W: invalid-url Source5: https://repository.jboss.org/nexus/service/local/repositories/releases/content/org/jboss/ironjacamar/ironjacamar-deployers-common/1.0.9.Final/ironjacamar-validator-1.0.9.Final.pom HTTP Error 404: The server has not found anything matching the request URI
ironjacamar.src: W: invalid-url Source4: https://repository.jboss.org/nexus/service/local/repositories/releases/content/org/jboss/ironjacamar/ironjacamar-deployers-common/1.0.9.Final/ironjacamar-common-impl-1.0.9.Final.pom HTTP Error 404: The server has not found anything matching the request URI
ironjacamar.src: W: invalid-url Source3: https://repository.jboss.org/nexus/service/local/repositories/releases/content/org/jboss/ironjacamar/ironjacamar-deployers-common/1.0.9.Final/ironjacamar-validator-cli-1.0.9.Final.pom HTTP Error 404: The server has not found anything matching the request URI
ironjacamar.src: W: invalid-url Source2: https://repository.jboss.org/nexus/service/local/repositories/releases/content/org/jboss/ironjacamar/ironjacamar-deployers-common/1.0.9.Final/ironjacamar-common-impl-papaki-1.0.9.Final.pom HTTP Error 404: The server has not found anything matching the request URI
ironjacamar.src: W: invalid-url Source0: ironjacamar-1.0.9.Final-CLEAN.tar.xz
1 packages and 0 specfiles checked; 0 errors, 14 warnings.

The URLs that fail can all be retrieved using the shell script snippet provided in the spec file.

Output of rpmlint of the binary packages:

$ rpmlint ironjacamar-1.0.9-2.fc18.noarch.rpm ironjacamar-javadoc-1.0.9-2.fc18.noarch.rpm
ironjacamar.noarch: W: invalid-url URL: http://www.jboss.org/ironjacamar HTTP Error 403: Forbidden
ironjacamar.noarch: W: class-path-in-manifest /usr/share/java/ironjacamar/ironjacamar-validator.jar
ironjacamar-javadoc.noarch: W: spelling-error Summary(en_US) Javadocs -> Java docs, Java-docs, Avocados
ironjacamar-javadoc.noarch: W: invalid-url URL: http://www.jboss.org/ironjacamar HTTP Error 403: Forbidden
2 packages and 0 specfiles checked; 0 errors, 4 warnings.

The Class-Path in manifest warning should be fixed.

[x]  Package is named according to the Package Naming Guidelines[1].
[x]  Spec file name must match the base package name, in the format %{name}.spec.
[x]  Package meets the Packaging Guidelines[2].
[x]  Package successfully compiles and builds into binary rpms.

Koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=3935789

[x]  Buildroot definition is not present
[!]  Package is licensed with an open-source compatible license and meets other legal requirements as defined in the legal section of Packaging Guidelines[3,4].

The header of the file common/src/main/resources/dtd/connector_1_0.dtd states a copyright and license terms that I think are not open source compatible. I think we can't distribute this content.

[x]  License field in the package spec file matches the actual license.
License type: LGPLv2+

[!]  If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package is included in %doc.

The file doc/licenses/lgpl-2.1.txt should be included as documentation.

[!]  All independent sub-packages have license of their own

The javadoc subpackage should include the doc/licenses/lgpl-2.1.txt file.

[x]  Spec file is legible and written in American English.
[x]  Sources used to build the package matches the upstream source, as provided in the spec URL.

Checked with a recursive diff of the sources. There are differences due to the differences of time zones and subversion variable expansion, but these are acceptable.

[x]  All build dependencies are listed in BuildRequires, except for any that are listed in the exceptions section of Packaging Guidelines[5].
[x]  Package must own all directories that it creates or must require other packages for directories it uses.
[x]  Package does not contain duplicates in %files.
[x]  File sections do not contain %defattr(-,root,root,-) unless changed with good reason
[x]  Permissions on files are set properly.
[x]  Package does NOT have a %clean section which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). (not needed anymore)
[x]  Package consistently uses macros (no %{buildroot} and $RPM_BUILD_ROOT mixing)
[x]  Package contains code, or permissable content.
[-]  Fully versioned dependency in subpackages, if present.
[-]  Package contains a properly installed %{name}.desktop file if it is a GUI application.
[x]  Package does not own files or directories owned by other packages.
[x]  Javadoc documentation files are generated and included in -javadoc subpackage
[x]  Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlinks)
[x]  Packages have proper BuildRequires/Requires on jpackage-utils
[x]  Javadoc subpackages have Require: jpackage-utils
[x]  Package uses %global not %define
[x]  If package uses tarball from VCS include comment how to re-create that tarball (svn export URL, git clone URL, ...)
[x]  If source tarball includes bundled jar/class files these need to be removed prior to building
[x]  All filenames in rpm packages must be valid UTF-8.
[x]  Jar files are installed to %{_javadir}/%{name}.jar (see [6] for details)
[x]  If package contains pom.xml files install it (including depmaps) even when building with ant
[x]  pom files has correct add_maven_depmap

=== Maven ===
[x]  Use %{_mavenpomdir} macro for placing pom files instead of %{_datadir}/maven2/poms
[-]  If package uses "-Dmaven.test.skip=true" explain why it was needed in a comment
[-]  If package uses custom depmap "-Dmaven.local.depmap.file=*" explain why it's needed in a comment
[x]  Package DOES NOT use %update_maven_depmap in %post/%postun
[x]  Packages DOES NOT have Requires(post) and Requires(postun) on jpackage-utils for %update_maven_depmap macro

=== Other suggestions ===
[x]  If possible use upstream build method (maven/ant/javac)
[x]  Avoid having BuildRequires on exact NVR unless necessary
[x]  Package has BuildArch: noarch (if possible)
[x]  Latest version is packaged.
[x]  Reviewer should test that the package builds in mock.

Tested on: http://koji.fedoraproject.org/koji/taskinfo?taskID=3935789

=== Issues ===
1. The jar file ironjacamar-validator.jar contains a Class-Path directive in the manifest.
2. We can't distribute the file common/src/main/resources/dtd/connector_1_0.dtd.
3. Missing license file in %doc (also in the javadoc package).

=== Final Notes ===
Sorry to be picky Ricardo, but I think that issues #1 to #3 need to be fixed, specially #2.

For #2 I think that the package will build and work just fine without the connecor_1_0.dtd file. Please remove it before creating the tarball, as you do with the .jar files. Also inform the upstream developers.

For #1 you could use a patch like this:

diff --git a/validator/build.xml b/validator/build.xml
index 00b5f8c..38b081c 100644
--- a/validator/build.xml
+++ b/validator/build.xml
@@ -90,7 +90,6 @@
         <attribute name="Implementation-Version" value="${version}"/>
         <attribute name="Implementation-Vendor" value="The IronJacamar project (http://www.jboss.org/ironjacamar)"/>
         <attribute name="Implementation-Vendor-Id" value="org.jboss"/>
-        <attribute name="Class-Path" value="jboss-logging.jar jboss-common-core.jar ${name}-spec-api.jar papaki-core.jar javassist.jar ${name}-common-api.jar ${name}-common-impl.jar"/>
       </manifest>
     </jar>
   </target>
@@ -119,7 +118,6 @@
         <attribute name="Implementation-Version" value="${version}"/>
         <attribute name="Implementation-Vendor" value="The IronJacamar project (http://www.jboss.org/ironjacamar)"/>
         <attribute name="Implementation-Vendor-Id" value="org.jboss"/>
-        <attribute name="Class-Path" value="${name}-validator.jar"/>
       </manifest>
     </jar>
        
@@ -135,7 +133,6 @@
         <attribute name="Implementation-Version" value="${version}"/>
         <attribute name="Implementation-Vendor" value="The IronJacamar project (http://www.jboss.org/ironjacamar)"/>
         <attribute name="Implementation-Vendor-Id" value="org.jboss"/>
-        <attribute name="Class-Path" value="${name}-validator.jar"/>
       </manifest>
     </jar>
        
@@ -151,7 +148,6 @@
         <attribute name="Implementation-Version" value="${version}"/>
         <attribute name="Implementation-Vendor" value="The IronJacamar project (http://www.jboss.org/ironjacamar)"/>
         <attribute name="Implementation-Vendor-Id" value="org.jboss"/>
-        <attribute name="Class-Path" value="${name}-validator.jar"/>
       </manifest>
     </jar>
   </target>
Comment 8 Ricardo Arguello 2012-03-28 01:24:42 EDT
I have reported upstream the issue with the connector_1_0.dtd file:

https://jira.jboss.org/jira/browse/JBJCA-775
Comment 9 Juan Hernández 2012-03-28 03:58:45 EDT
I am not 100% sure if the connector_1_0.dtd file is acceptable. Having it out of the package makes things easier.

I don't see any reason to block this package now. Thank you very much!

================
*** APPROVED ***
================
Comment 10 Ricardo Arguello 2012-03-28 08:50:00 EDT
New Package SCM Request
=======================
Package Name: ironjacamar
Short Description: Java Connector Architecture 1.6 implementation
Owners: ricardo
Branches: f17
InitialCC: goldmann
Comment 11 Gwyn Ciesla 2012-03-28 09:10:43 EDT
Git done (by process-git-requests).
Comment 12 Fedora Update System 2012-03-28 17:11:34 EDT
ironjacamar-1.0.9-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/ironjacamar-1.0.9-3.fc17
Comment 13 Fedora Update System 2012-03-29 22:58:02 EDT
ironjacamar-1.0.9-3.fc17 has been pushed to the Fedora 17 testing repository.
Comment 14 Fedora Update System 2012-04-11 23:33:16 EDT
ironjacamar-1.0.9-3.fc17 has been pushed to the Fedora 17 stable repository.

Note You need to log in before you can comment on or make changes to this bug.